//--
//--	buffer.hpp
//--
//--	TBuffer Class Header File
//--
//--  Most variables are public to speed access to them


#if !defined(__ULU_BUFFER_H)
#define __ULU_BUFFER_H


#include <owl\module.h>
#include <owl\point.h>
#include <owl\dc.h>
#include <owl\gdiobjec.h>
#define STRICT
#include <owl\window.h>
#pragma hdrstop
#include "wingdc.h"
#include "palette.h"

typedef struct tagOFFSCREENBUFFERHEADER
{
	BITMAPINFOHEADER Header;
	RGBQUAD aColors[256];
}  OFFSCREENBUFFERHEADER;

class TBuffer {

	public:

		TBuffer(TSize, TIdentityPalette *);
		virtual ~TBuffer();

		TWinGDC *pBufferDC; 
		int nWidth, nHeight;
		long lBMPOrientation;   // 1 or -1
		virtual void EraseBuffer(uint32 rop);// Set the buffer to rop
		void far *pOffScreenBits;
		TDC *GetWinGDC()  {return pBufferDC;}

	protected:


		HBITMAP hbmOldMonoBitmap;
		OFFSCREENBUFFERHEADER BufferHeader;
		HBITMAP BuildOffScreenDIB(int nXSize, int nYSize);
		void RebuildOffScreenDIB(int nXSize, int nYSize);
		TIdentityPalette *pPalette;

};
#endif  //  #if !defined(__ULU_BUFFER_H)

